<template lang="pug">
//- q-page-sticky(expand position="top-left" :scroll-offset="150" :offset="[10, 10]")
.q-pr-sm
  q-list(dense, separator)
    .text-h4.text-center {{ user.score || 0 }}

    q-item
      q-item-label.q-py-md.text-uppercase(overline) {{ $t('LEADERBOARD') }}

    q-item(v-for="leader of leaderboard.toplist", :key="leader.name")
      q-item-section(avatar, style="width: 100px")
        .text-body1 {{ leader.score }}

      q-item-section
        q-chip
          q-avatar.bg-primary(icon="person", circle, text-color="white")
          span.ellipsis {{ leader.name }}
    q-item
      q-item-label.q-py-md.text-uppercase(overline) {{ $t('STATS') }}

    q-item
      q-item-section(avatar, style="width: 100px")
        .text-body1 {{ leaderboard.perday }}
      q-item-section
        span {{ $t('score_per_day') }}

    q-item
      q-item-section(avatar, style="width: 100px")
        .text-body1 {{ leaderboard.perperson }}
      q-item-section
        span {{ $t('average_score_per_person') }}

    q-item
      .text-caption {{ $t('score_caveat') }}
    q-item
      q-item-label.q-py-md.text-uppercase(overline) {{ $t('COMPLETED') }}
    q-item(v-for="lang in leaderboard.langs", :key="lang.lang")
      q-item-section(side, style="width: 100px") {{ codeToLang(lang.lang) }}
      q-item-section
        q-linear-progress(:value="lang.completed")
</template>

<script>
import { db } from "@/db";
import { mapState } from "vuex";
import Language from "@/mixins/Language";

export default {
  mixins: [Language],
  data: () => {
    return {
      leaderboard: {},
    };
  },
  firestore: {
    leaderboard: db.collection("config").doc("leaderboard"),
  },
  computed: {
    ...mapState({
      user: (state) => state.user,
    }),
  },
};
</script>
